// L138_prbs_deemph_intr.c
//

#include "L138_aic3106_init.h"
#include "evmomapl138_dip.h"
#include "evmomapl138_led.h"

AIC31_data_type codec_data;

interrupt void interrupt4(void) // interrupt service routine
{
  codec_data.channel[0] = prbs();
  codec_data.channel[1] = codec_data.channel[0];
  output_sample(codec_data.uint);
  return;
}

int main(void)
{
  uint32_t rtn;
  uint8_t  newDIP_value;

  L138_initialise_intr(FS_8000_HZ,ADC_GAIN_0DB,DAC_ATTEN_0DB);
  rtn = LED_init();
  if (rtn != ERR_NO_ERROR)
  {
    printf("error initializing leds!\r\n");
    return (rtn);
  }
      
  rtn = DIP_init();
  if (rtn != ERR_NO_ERROR)
  {
    printf("error initializing dip switches!\r\n");
    return (rtn);
  }
  
  while(1) 
  {
	rtn = DIP_get(0, &newDIP_value);
    if(newDIP_value == 0) 
    {
      LED_turnOn(0);
      AIC3106_writeRegister(  0, 0x00 ); 
      AIC3106_writeRegister( 12, 0x00 ); 
    }
    else
    {
      LED_turnOff(0);
      AIC3106_writeRegister(  0, 0x00 ); 
      AIC3106_writeRegister( 12, 0x05 ); 
    }
	rtn = DIP_get(1, &newDIP_value);
    if(newDIP_value == 0) 
    {
      LED_turnOn(1); // default de-emph
      AIC3106_writeRegister(  0, 0x01 ); 
      AIC3106_writeRegister( 21, 0x39 ); 
      AIC3106_writeRegister( 22, 0x55 ); 
      AIC3106_writeRegister( 23, 0xF3 ); 
      AIC3106_writeRegister( 24, 0x2D ); 
      AIC3106_writeRegister( 25, 0x53 ); 
      AIC3106_writeRegister( 26, 0x7E ); 
      AIC3106_writeRegister( 47, 0x39 ); 
      AIC3106_writeRegister( 48, 0x55 ); 
      AIC3106_writeRegister( 49, 0xF3 ); 
      AIC3106_writeRegister( 50, 0x2D ); 
      AIC3106_writeRegister( 51, 0x53 ); 
      AIC3106_writeRegister( 52, 0x7E ); 
    }
    else
    {
      LED_turnOff(1); //HPF on L and R
      AIC3106_writeRegister(  0, 0x01 ); 
      AIC3106_writeRegister( 21, 0x5F ); 
      AIC3106_writeRegister( 22, 0xFF ); 
      AIC3106_writeRegister( 23, 0xa0 ); 
      AIC3106_writeRegister( 24, 0x00 ); 
      AIC3106_writeRegister( 25, 0x10 ); 
      AIC3106_writeRegister( 26, 0x00 ); 
      AIC3106_writeRegister( 47, 0x5F ); 
      AIC3106_writeRegister( 48, 0xFF ); 
      AIC3106_writeRegister( 49, 0xa0 ); 
      AIC3106_writeRegister( 50, 0x00 ); 
      AIC3106_writeRegister( 51, 0x10 ); 
      AIC3106_writeRegister( 52, 0x00 ); 
    }
  }
}


