// L138_record_poll.c
//

#include "L138_aic3106_init.h"

#define SAMPLING_FREQ     48000
#define RECORD_SECONDS    5
#define SILENT_SECONDS    2
#define RECORD_SAMPLES    RECORD_SECONDS * SAMPLING_FREQ
#define SILENT_SAMPLES    SILENT_SECONDS * SAMPLING_FREQ

uint32_t i;
uint32_t buffer[RECORD_SAMPLES];
#pragma DATA_SECTION(buffer,".EXT_RAM") // locate buffer
                                        // in external memory

int main()
{
  uint32_t sample;

  L138_initialise_poll(FS_48000_HZ,ADC_GAIN_0DB,DAC_ATTEN_0DB);

  while(1)
  {
  	for (i=0; i<RECORD_SAMPLES; i++) // record from LINE IN
    {                                // to buffer 
  	  sample =  input_sample();      // for RECORD_TIME_SECONDS
      buffer[i] = sample;
      output_sample(sample); 
    }

  for (i=0;i<SILENT_SAMPLES;i++) output_sample(0);
  

  for (i=0;i<RECORD_SAMPLES;i++)     // play back to LINE OUT
  {                                  // from buffer
    sample = buffer[i];
    output_sample(sample);
  }
  for (i=0;i<SILENT_SAMPLES;i++) output_sample(0);
  }
}
 
