// L138_fir4types_intr.c
//

#include "L138_aic3106_init.h"
#include "evmomapl138_dip.h"
#include "L138_fir4types_coeffs.h" 

uint32_t FIR_number = 0;
float dly[N];          		    // filter delay line
float h[4][N];      			// filter coefficients

interrupt void interrupt4(void) // interrupt service routine
{
  int i;
  float yn = 0.0;
 
//  dly[0] = (float)(input_left_sample()); // input from ADC
  dly[0] = (float)(prbs()); // input from ADC
  for (i = 0; i< N; i++)                 // compute output
    yn +=(h[FIR_number][i]*dly[i]);
  for (i = N-1; i > 0; i--)              // shift delay line
    dly[i] = dly[i-1];
  output_left_sample((uint16_t)(yn));    // output to DAC
  return;
}

int main()
{
  uint32_t DIP_value, rtn;
  int i;

  for (i=0; i<N; i++)
  { 
	dly[i] = 0.0;
  	h[0][i] = hlp[i];  	    
   	h[1][i] = hhp[i];
   	h[2][i] = hbp[i];
   	h[3][i] = hbs[i];
  }
  L138_initialise_intr(FS_8000_HZ,ADC_GAIN_0DB,DAC_ATTEN_0DB);
  rtn = DIP_init();         // initialise user DIP switches
  if (rtn != ERR_NO_ERROR)
  {
    printf("error initializing dip switches!\r\n");
    return (rtn);
  }
  while(1)
  {
    rtn = DIP_getAll(&DIP_value);  // read user DIP switches
    FIR_number = (DIP_value % 4);  // switch filter coeffs
  }
}

