// L138_iirsos_DSPLIB_edma.c
//

#include "L138_aic3106_init.h"
#include "dsplib674x.h"

#include "elliptic.cof"

extern int16_t *pingIN, *pingOUT, *pongIN, *pongOUT;
volatile int buffer_full = 0;
int procBuffer;
float delay[NUM_SECTIONS][2] = {0.0};

float x[BUFCOUNT/2];
float y[BUFCOUNT/2];

interrupt void interrupt4(void) // associated in intvecs.asm with INT4
                                // should be called every time there's
								// an EDMA3 transfer completion
{
 switch(EDMA_3CC_IPR)
  {
    case 1:
      procBuffer = PING;                 // we should process ping
	  EDMA_3CC_ICR = 0x0001; // clear EDMA3 IPR bit 0 (TCC = 0)
	  break;
    case 2:
      procBuffer = PONG;                 // we should process pong
	  EDMA_3CC_ICR = 0x0002; // clear EDMA3 IPR bit 1 (TCC = 1)
	  break;
    default:
	  EDMA_3CC_ICR = 0x0003; // clear EDMA3 IPR bits 0 and 1 (during GEL both flags may have been set)
      break;
  }

  EVTCLR0 = 0x00000100;
  buffer_full = 1;             // global flag indicates switch of buffers
return;
}

void process_buffer(void) // should be called from infinite loop in main
                          // program when process buffer has been filled
{
int16_t *inBuf, *outBuf; // temporary pointer to current process buffer
int i;
int section;
float  *inptr, *outptr, *tempptr;

if (procBuffer == PING)
{
  inBuf = pingIN;
  outBuf = pingOUT;
}
else
{
  inBuf = pongIN;
  outBuf = pongOUT;
}

for (i = 0; i < (BUFCOUNT/2) ; i++) 
{
 // x[i] = (float)(*inBuf);
  x[i] = (float)(prbs());
  inBuf++;
//  x[i] = (float)(*inBuf);
  inBuf++;
}
  	inptr = x;
    outptr = y;


for(section = 0 ; section < NUM_SECTIONS ; section++)
{
  DSPF_sp_biquad(inptr,&b[section][0],&a[section][0],&delay[section][0],outptr,(BUFCOUNT/2));
tempptr = outptr;
outptr = inptr;
inptr = tempptr;
}

for (i = 0; i < (BUFCOUNT/2) ; i++) 
{
  *outBuf++ = (int16_t)(*inptr);
  *outBuf++ = (int16_t)(*inptr++);
//  outBuf++;
//  *outBuf =(int16_t)(x[i]);
//  outBuf++;
}

buffer_full = 0; // indicate that buffer has been processed

return;
}



int main(void)
{
L138_initialise_edma(FS_8000_HZ,ADC_GAIN_0DB,DAC_ATTEN_0DB);

  while(1) 
  {
    while (!buffer_full);
     process_buffer();
  }

}  // end of main()




