// L138_bios_LED_PRD.c
//

#include "stdio.h"
#include "stdlib.h"
#include "types.h"
#include "evmomapl138.h"
#include "evmomapl138_gpio.h"
#include "evmomapl138_i2c.h"
#include "evmomapl138_led.h"
#include <std.h>
#include <clk.h>


void main(void)
{
   	I2C_init(I2C0, I2C_CLK_400K);				// init I2C channel
	LED_init();									// init LED and DIP BSL
	return;  									// return to BIOS scheduler
}												 



//-----------------------------------------------------------------------------
// USTIMER_delay()
//
// LogicPD BSL fxn - re-written for a few BSL.c files that need it.
// The original USTIMER_init() is not used because it is NOT BIOS compatible
// and took both timers so that BIOS PRDs would not work. This is a 
// workaround.
//
// If you need a "delay" in this app, call this routine with the number
// of usec's of delay you need. It is approximate - not exact.
// value for time<300 is perfect for 1us. We padded it some.
//-----------------------------------------------------------------------------

void USTIMER_delay(uint32_t usec)
{
	volatile int32_t i, start, time, current;

	for (i=0; i<usec; i++)
	{
		start = CLK_gethtime();
		time = 0;
		while (time < 350)
		{
			current = CLK_gethtime();
			time = current - start;
		}
	}
}
void ledToggle(void)					//called by IDL thread or PRD
{
	LED_toggle(0);					//toggle LED_1 on C6748 EVM
}
   
void ledToggle1(void)					//called by IDL thread or PRD
{
	LED_toggle(1);					//toggle LED_1 on C6748 EVM
}







