// L138_bios_fir_intr_SWI.c
//

#include <std.h>
#include <swi.h>

#include "L138_bios_aic3106_init.h"

#include "lp33.cof"                //filter coefficient file
float yn;                          //filter output
float x[N];                        //filter delay line

extern far SWI_Obj SWI_fir_isr;

void interrupt4(void) 
{  
  x[0] = (float)(input_right_sample()); //get new input into delay line
  output_left_sample((short)(yn));     //output to codec
  SWI_post(&SWI_fir_isr);
  return;
}

void fir_isr(void)
{
  short i;
    yn = 0.0;                       //initialise filter output
  for (i=0 ; i<N ; i++)           //calculate filter output
    yn += h[i]*x[i];
  for (i=(N-1) ; i>0 ; i--)       //shuffle delay line contents
    x[i] = x[i-1];                //I know it's inefficient
  return;
}

int main(void)
{

  L138_bios_initialise_intr(FS_8000_HZ,ADC_GAIN_0DB,DAC_ATTEN_0DB);


}  // end of main()
